; externals for PLAY32 v1.13 soundsystem
; (c) 1995/96 Oliver 'rOK!' Kferstein [Keen like Frogs]

EXTRN           p32_INIT        : NEAR      ; inits PLAY32
                                            ; ->NEEDS! EDi=pointer to soundfile
EXTRN           p32_CLOSE       : NEAR      ; shuts PLAY32 down
EXTRN           p32_START       : NEAR      ; starts playing
EXTRN           p32_STOP        : NEAR      ; stops playing
EXTRN           p32_reINIT      : NEAR      ; re-init PLAY32 for NEXT soundfile
                                            ; ->NEEDS! EDi=pointer to soundfile
EXTRN           p32_waitROW     : NEAR      ; delays till a specified patternrow in EAX

; detect routines
EXTRN           SBResetDSP      : NEAR      ; resets SB DSP chip, cf on error
EXTRN           SBWrite         : NEAR      ; writes a SB value
EXTRN           SBread          : NEAR      ; reads a SB value

EXTRN           GetGUSrev       : NEAR      ; returns GUS CODEC rev. in edx
EXTRN           GetSBrev        : NEAR      ; returns SB DSP rev. in edx

EXTRN           INIT            : NEAR      ; init PLAY32 replay's

EXTRN           ScreenAdr       : DWORD     ; the Textmode screen adress
EXTRN           Scard           : DWORD     ; the choosen Soundcard
EXTRN           Choice          : DWORD     ; The suggested choice

EXTRN           AvailCards      : DWORD     ; the SoundCard Struct

; replay's
EXTRN           OrderPos        : DWORD     ; current played order position
EXTRN           OrderLength     : DWORD     ; current played songs order lenght
EXTRN           OrderList       : BYTE      ; the Order List (128 byte LABELED)
EXTRN           PatternRow      : DWORD     ; current played pattern row
EXTRN           RowsPlayed      : DWORD     ; rows played since start (replay)
EXTRN           Tempo           : DWORD     ; current Patternspeed
EXTRN           TempoCount      : DWORD     ; current speed counter
EXTRN           BPM             : DWORD     ; current BPM value
EXTRN           RestartPos      : DWORD     ; Orderposition Restart Value
EXTRN           ActiveVoices	: DWORD     ; Active Voices from MODule

; calculated Tables
EXTRN           ArpTable        : DWORD     ; Arpeggio Table
EXTRN           SinTable        : DWORD     ; Sine/Ramp/Square Table
EXTRN           FreqPointerGEN  : DWORD     ; generated MOD freq table
EXTRN           FreqTable       : DWORD     ; generated Frequency lookup table

; The PLAY32 soundcard struct
SoundCard       STRUC
                Port        dd  0           ; baseport
                Irq         dd  0           ; Soundcard IRQ level
                DMA         dd  0           ; Soundcard DMA channel
                Ver         dd  0           ; Soundcard version
SoundCard       ENDS

SupportedCards  EQU     2                   ; currently 3 Soundcard supported

; graphic stuff
VGA_Text        EQU     0B8000h
VGA_Gfx         EQU     0A0000h

EXTRN           ChangeCursor    : NEAR      ; changes Text cursor visible<>invisible


; Color_Str constants
black           EQU     0
blue            EQU     1
green           EQU     2
cyan            EQU     3
red             EQU     4
pink            EQU     5
brown           EQU     6
white           EQU     7
grey            EQU     8
Lblue           EQU     9
Lgreen          EQU     10
Lcyan           EQU     11
Lred            EQU     12
Lpink           EQU     13
yellow          EQU     14
Lwhite          EQU     15
ON              EQU     +16+
EOS             EQU     31                  ; End of STRING
RepC            EQU     29                  ; Repeat Character
Line            EQU     30                  ; Jump to Line
